###############################################################################
#
# Copyright 2006 by refline (Schweiz) AG, CH-5630 Muri
#
###############################################################################
"""Special Fields

$Id: field.py 73916 2007-03-29 15:28:25Z dobe $
"""
__docformat__ = "reStructuredText"

import re

import zope.interface
import zope.schema

from z3c.schema.hostname import interfaces


isValidHostName = re.compile(

    # BEGIN: host
    r"([a-zA-Z]+([a-zA-Z\d\-]*[a-zA-Z\d])*"
    r"(\.[a-zA-Z\d]+([a-zA-Z\d\-]*[a-zA-Z\d])*)*"
    # END: host

    # or
    r"|"

    # BEGIN: IP
    r"([1-9][\d]{0,1}|1[\d]{0,2}|2[0-5]{0,2})"
    r"(\.([\d]{1,2}|1[\d]{0,2}|2[0-5]{0,2})){3})"
    # END: IP

    # port
    r"(:[\d]{1,5})?$"
    ).match


class HostName(zope.schema.URI):
    """HostName schema field.

    This is a IP Address or a host name.
    """

    zope.interface.implements(interfaces.IHostName)

    def _validate(self, value):
        if isValidHostName(value):
            return
        raise interfaces.InvalidHostName, value

    def fromUnicode(self, value):
        v = str(value.strip())
        self.validate(v)
        return v
